local entity_id = GetUpdatedEntityID()
local x, y = EntityGetTransform(entity_id)
SetRandomSeed(x, y)
local amount = 7
local radii = { 17, 20, 22, 21}
for i=1, amount do
  for r=1, 4 do
    local angle = (i / amount) * math.pi * 2
    local radius = radii[r]
    local rotational_velocity = 80
    local comp = EntityAddComponent2(entity_id, "ParticleEmitterComponent", {
      emitted_material_name=r < 3 and "spark_yellow" or "spark_red",
      lifetime_min=2,
      lifetime_max=3,
      x_vel_min=math.cos(angle + math.rad(90)) * rotational_velocity,
      x_vel_max=math.cos(angle + math.rad(90)) * rotational_velocity,
      y_vel_min=math.sin(angle + math.rad(90)) * rotational_velocity,
      y_vel_max=math.sin(angle + math.rad(90)) * rotational_velocity,
      x_pos_offset_min=math.cos(angle) * radius,
      x_pos_offset_max=math.cos(angle) * radius,
      y_pos_offset_min=math.sin(angle) * radius,
      y_pos_offset_max=math.sin(angle) * radius,
      friction=0.8,
      count_min=1,
      count_max=1,
      render_on_grid=false,
      fade_based_on_lifetime=true,
      cosmetic_force_create=true,
      collide_with_grid=false,
      draw_as_long=true,
      airflow_force=0.051,
      airflow_time=1.01,
      airflow_scale=0.03,
      emission_interval_min_frames=2,
      emission_interval_max_frames=4,
      emit_cosmetic_particles=true,
      attractor_force=r*(50/3.8),
      render_back=true,
      is_emitting=true,
    })
    ComponentSetValue2(comp, "gravity", 0, 0)
  end
end






--[[ 
local entity_id = GetUpdatedEntityID()
local amount = 11
for i=1, amount do
  for r=1, 3 do
    local angle = (i / amount) * math.pi * 2
    local radius = r * 7
    local rotational_velocity = 130
    local comp = EntityAddComponent2(entity_id, "ParticleEmitterComponent", {
      emitted_material_name="spark_yellow",
      lifetime_min=3,
      lifetime_max=4,
      x_vel_min=math.cos(angle + math.rad(90)) * rotational_velocity,
      x_vel_max=math.cos(angle + math.rad(90)) * rotational_velocity,
      y_vel_min=math.sin(angle + math.rad(90)) * rotational_velocity,
      y_vel_max=math.sin(angle + math.rad(90)) * rotational_velocity,
      x_pos_offset_min=math.cos(angle) * radius,
      x_pos_offset_max=math.cos(angle) * radius,
      y_pos_offset_min=math.sin(angle) * radius,
      y_pos_offset_max=math.sin(angle) * radius,
      friction=0.7,
      count_min=1,
      count_max=1,
      render_on_grid=false,
      fade_based_on_lifetime=true,
      cosmetic_force_create=true,
      collide_with_grid=false,
      airflow_force=0.051,
      airflow_time=1.01,
      airflow_scale=0.03,
      emission_interval_min_frames=1,
      emission_interval_max_frames=3,
      emit_cosmetic_particles=true,
      attractor_force=r*(50/3),
      render_back=true,
      is_emitting=true,
    })
    ComponentSetValue2(comp, "gravity", 0, 0)
  end
end


 ]]