local nxml = dofile_once("mods/VolcanoBiome/lib/nxml.lua")
ModRegisterAudioEventMappings("mods/VolcanoBiome/audio/GUIDs.txt")
ModMagicNumbersFileAdd("mods/VolcanoBiome/files/magic_numbers.xml")
ModMaterialsFileAdd("mods/VolcanoBiome/files/materials.xml")

ModLuaFileAppend("data/scripts/biomes/temple_altar_left.lua", "mods/VolcanoBiome/files/scripts/temple_altar_left_append.lua")
-- No NG+ and Nightmare mode support for now, too much of a pain in the ass
-- ModLuaFileAppend("mods/nightmare/files/biome_map.lua", "mods/VolcanoBiome/files/scripts/map_loader.lua")
-- ModLuaFileAppend("data/biome_impl/biome_map_newgame_plus.lua", "mods/VolcanoBiome/files/scripts/ngplus.lua")

local content = ModTextFileGetContent("data/biome/_biomes_all.xml")
local xml = nxml.parse(content)
xml:add_children(nxml.parse_many[[
	<Biome height_index="0" color="ff9c4b79" biome_filename="mods/VolcanoBiome/files/biome/entrance.xml" />
	<Biome height_index="0" color="ff78375c" biome_filename="mods/VolcanoBiome/files/biome/inside.xml" />
	<Biome height_index="0" color="ff712f55" biome_filename="mods/VolcanoBiome/files/biome/bottom.xml" />
	<Biome height_index="0" color="ff873665" biome_filename="mods/VolcanoBiome/files/biome/exit.xml" />
]])
ModTextFileSetContent("data/biome/_biomes_all.xml", tostring(xml))

function OnPlayerSpawned(player)
	local bgm_script_found = false
	local bgm_script_path = "mods/VolcanoBiome/files/scripts/background_music_checker.lua"
	for i, comp in ipairs(EntityGetComponentIncludingDisabled(player, "LuaComponent")) do
		if ComponentGetValue2(comp, "script_source_file") == bgm_script_path then
			bgm_script_found = true
			break
		end
	end
	if not bgm_script_found then
		EntityAddComponent2(player, "LuaComponent", {
			script_source_file=bgm_script_path,
			execute_every_n_frame=30,
		})
	end
end
